#include <stdio.h>
#include <stdlib.h>
#if 0
#include <string.h>
#endif
#include <sys/socket.h>
#include <netinet/in.h>

#include "newinfi.h"

int sock;  /* The Master socket */
#ifdef USE_IPV6
struct sockaddr_in6 lsa; /* Local socket address */
#else /* ndef USE_IPV6 */
struct sockaddr_in lsa; /* Local socket address */
#endif /* ndef USE_IPV6 */
const socklen_t lsa_len = sizeof(lsa); /* Size of above */

#ifdef USE_IPV6
static int family = PF_INET6;
#else /* ndef USE_IPV6 */
static int family = PF_INET;
#endif /* ndef USE_IPV6 */
static int socktype = SOCK_STREAM;

void
do_bind (void)
{
  int v;
  int reuse;
  struct linger linger;

  sock = socket (family, socktype, 0);
  if ( sock < 0 )
    {
      perror ("socket");
      exit (EXIT_FAILURE);
    }
  reuse = 1;
  if ( setsockopt (sock, SOL_SOCKET, SO_REUSEADDR, &reuse, sizeof(reuse)) < 0 )
    {
      perror ("setsockopt");
    }
  linger.l_onoff = 1;
  linger.l_linger = MAXDELAY;
  if ( setsockopt (sock, SOL_SOCKET, SO_LINGER, &linger, sizeof(linger)) < 0 )
    {
      perror ("setsockopt");
    }
#if 0 /* Not necessary: static allocation is cleared */
  memset (&lsa, 0, sizeof(lsa));
#endif
#ifdef USE_IPV6
  lsa.sin6_family = AF_INET6;
  lsa.sin6_port = htons (PORTNUM);
  lsa.sin6_addr = in6addr_any;
#else /* ndef USE_IPV6 */
  lsa.sin_family = AF_INET;
  lsa.sin_port = htons (PORTNUM);
  lsa.sin_addr.s_addr = htonl (INADDR_ANY);
#endif /* ndef USE_IPV6 */
  v = bind (sock, (struct sockaddr *)&lsa, lsa_len);
  if ( v < 0 )
    {
      perror ("bind");
      exit (EXIT_FAILURE);
    }
  v = listen (sock, MAXTHREADS);
  if ( v < 0 )
    {
      perror ("listen");
      exit (EXIT_FAILURE);
    }
}
