#include <stdarg.h>
#include <stdio.h>
#include <string.h>

size_t
rscpy (char buf[], size_t buf_size, size_t *buf_len,
       const char str[], size_t str_len)
{
  size_t len;

  len = str_len;
  if ( len > buf_size )
    len = buf_size;
  memcpy (buf, str, len);
  if ( buf_len )
    *buf_len = len;
  return len;
}

size_t
rsprintf (char buf[], size_t buf_size, size_t *buf_len,
	  const char template[], ...)
     /* Yet Another snprintf() variant.  Since there are several
      * different return value conventions for snprintf(), and since
      * the ISO C99 spec is not agreeable, we encapsulate.  Here, buf
      * is guaranteed to be null-terminated, and the return value
      * (also stored in buf_len if it is not NULL) is the number of
      * characters _actually written_, not counting the final nul,
      * hence at most buf_size-1. */
{
  va_list ap;
  int len;

  va_start (ap, template);
  len = vsnprintf (buf, buf_size, template, ap);
  va_end (ap);
  if ( len < 0 || (size_t)len >= buf_size-1 )
    {
      buf[buf_size-1] = 0;
      if ( buf_len )
	*buf_len = buf_size-1;
      return buf_size-1;
    }
  else
    {
      if ( buf_len )
	*buf_len = len;
      return len;
    }
}
